using System;

class MatrixMultiplicationDemo
{
	static void PrintMatrix(int[,] aMatrix) 
	{
		for (int row = 0; row < aMatrix.GetLength(0); row++)
		{
			for (int col = 0; col < aMatrix.GetLength(1); col++)
			{
				Console.Write("{0} ", aMatrix[row, col]);
			}
			Console.WriteLine();
		}
		Console.WriteLine();
	}

	static int[,] Mult(int[,] aMatrix1, int[,] aMatrix2)
	{
		int width1 = aMatrix1.GetLength(1);
		int height1 = aMatrix1.GetLength(0);
		int width2 = aMatrix2.GetLength(1);
		int height2 = aMatrix2.GetLength(0);

		if (width1 != height2)
		{
			throw new ArgumentException("Invalid dimensions!");
		}

		int[,] resultMatrix = new int[height1, width2];
		for (int row = 0; row < height1; row++) 
		{
			for (int col = 0; col < width2; col++) 
			{
				resultMatrix[row, col] = 0;
				for (int i = 0; i < width1; i++)
				{
					resultMatrix[row, col] += 
						aMatrix1[row, i] * aMatrix2[i, col];
				}
			}
		}

		return resultMatrix;
	}

	static void Main(string[] args)
	{
		int[,] m1 = new int[4,2]
		{
			{1,2},
			{3,4},
			{5,6},
			{7,8}
		};
		PrintMatrix(m1);

		int[,] m2 = new int[2,3] 
		{
			{1,2,3},
			{4,5,6}
		};
		PrintMatrix(m2);

		int[,] m3 = Mult(m1, m2);
		PrintMatrix(m3);
	}
}