using System;
using System.Collections;

class Student
{
	protected string mName;
	protected int mAge;

	public Student(string aName, int aAge)
	{
		mName = aName;
		mAge = aAge;
	}

	public override string ToString()
	{
		return String.Format(
			"({0}, {1})", mName, mAge);
	}

	public override bool Equals(object aStudent)
	{
		if ((aStudent==null) || !(aStudent is Student))
			return false;

		Student student = (Student) aStudent;

		bool equals = (mName == student.mName) &&
			(mAge == student.mAge);
		return equals;
	}

	public override int GetHashCode()
	{
		int hashCode = mName.GetHashCode() ^ mAge; 
		return hashCode;
	}
}

class HashCodesDemo
{
	private static Hashtable mAddressTable;

	static void PrintAddress(Student aStudent)
	{
		if (mAddressTable.ContainsKey(aStudent))
		{
			Console.WriteLine("{0}  : {1}.",
				aStudent, mAddressTable[aStudent]);
		}
		else 
		{
			Console.WriteLine("   {0}.", aStudent);
		}
	}

	static void Main()
	{
		Student ivan = new Student(" ", 67);
		Student yaga = new Student(" ", 318);
		Student kiro = new Student(" ", 38);

		mAddressTable = new Hashtable();
		mAddressTable.Add(ivan, ". ,  ");
		mAddressTable.Add(yaga, " ");
		mAddressTable.Add(kiro, ", . ");

		PrintAddress(ivan);
		PrintAddress(new Student(" ", 318));
		PrintAddress(new Student(" ", 24));
	}
}